
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>图的表示javascript / 憋错料</title>

    <meta name="description" content="图的表示javascript 乍一看,图和树或者二叉树很像,但是采用基于对象的方式来构建就会有问题,因为图可能会增长到非常大,用对象来表示就会使效率低下. 首先我们需要定义一个图的类,其中通过adj数组来表示邻接表,也就是与节点相关联的节点数组:marked数组则是用来表示该节点是否被访问过,是在深度优先搜索和广度优先搜索中用到的. function Graph(v){//图类 this.vertices=v;//结点数 this.edges=0;//边数 this.adj=[];//数组存放顶点数量 for(var i=0">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">图的表示javascript</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>乍一看，图和树或者二叉树很像，但是采用基于对象的方式来构建就会有问题，因为图可能会增长到非常大，用对象来表示就会使效率低下。</p>
<p>首先我们需要定义一个图的类，其中通过adj数组来表示邻接表，也就是与节点相关联的节点数组；marked数组则是用来表示该节点是否被访问过，是在深度优先搜索和广度优先搜索中用到的。</p>
<pre>		function Graph(v){//图类
		this.vertices=v;//结点数
		this.edges=0;//边数
		this.adj=[];//数组存放顶点数量
		for(var i=0;i&lt;this.vertices;i++){
			this.adj[i]=[];//子数组存储相邻顶点
		}
		this.addEdge=addEdge;//添加边
		this.showGraph=showGraph;//显示图
		this.dfs=dfs;//深度优先搜索
		this.bfs=bfs;//广度优先搜索
		this.marked=[];//标识位数组
		for(var i=0;i&lt;this.vertices;i++){//给所有结点添加未访问过的标识位
			this.marked[i]=false;
		}
	}
</pre>
<p>然后需要定义一个函数来添加双边关系，代码如下：</p>
<pre>	function addEdge(v,w){//添加边
		this.adj[v].push(w);//将w添加到v的相邻顶点列表
		this.adj[w].push(v);//将v添加到w的相邻顶点列表
		this.edges++;//边数加一
	}
</pre>
<p>接下来定义一个显示图关系的函数，代码如下：</p>
<pre>function showGraph(){//显示图
		for(var i=0;i&lt;this.vertices;i++){
			document.write(i+&quot;-&gt;&quot;);
			for(var j=0;j&lt;this.vertices;j++){
				if(this.adj[i][j]!=undefined){//显示和该结点相邻的结点
					document.write(this.adj[i][j]+&quot; &quot;);
				}
			}
			document.write(&quot;&lt;br&gt;&quot;);
		}
	}
</pre>
<p>下面就可以来进行测试了：</p>
<pre>g=new Graph(5);
	g.addEdge(0,1);
	g.addEdge(0,2);
	g.addEdge(1,3);
	g.addEdge(2,4);
g.showGraph();
</pre>
<p>实验结果为：</p>
<p>//结果</p>
<p>//&nbsp; 0-&gt; 1 2</p>
<p>//&nbsp; 1-&gt; 0 3</p>
<p>//&nbsp; 2-&gt; 0 4</p>
<p>//&nbsp; 3-&gt; 1</p>
<p>// 4-&gt; 2</p>
<p>一个图就表示出来啦。下一节会讲到广度优先和深度优先搜索的实现。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 06:33:39 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>图的表示javascript的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEkGqx3.html" rel="bookmark">一张图看懂JavaScript中数组的迭代方法：forEach、map、filter、reduce、every、some</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				好吧,竟然不能单发一张图,不够200字啊不够200字! 在&lt;JavaScript高级程序设计&gt;中,分门别类介绍了非常多数组方法,其中迭代方法里面有6种,这6种方法在实际项目有着非常广泛的作用.其中本人最爱用forEach和map,好用又高效,不用什么都是for循环大法.但是初学的时候往往觉得头大,这些方法都很像,到底有什么区别?趁着今天有空,我把对着6个方法的认知,用最浅显的图画出来,希望看到的同学觉得有用.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Y9y60.html" rel="bookmark">干货：11张思维导图详解JavaScript</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习的道路就是要不断的总结归纳,好记性不如烂笔头. 但是,毫无逻辑的总结,并无太大意义,一份有规划有流程的总结往往能有事半功倍的作用. 下面小编将po出11张JavaScript相关的思维导图,建议WiFi下查看. 分别归类为: javascript变量 javascript运算符 javascript数组 javascript流程语句 Javascript数据类型 javascript字符串函数 javascript函数基础 javascript基础DOM操作 javascript正则表达式			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xnDRz4.html" rel="bookmark">图的最短路径javascript</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图中一个结点到另一个结点的最短路径,可以应用到很多现实问题上来.在执行广度优先搜索时,会自动查找从一个顶点到另一个相连顶点的最短路径.例如,查找a到d的最短路径,首先会查找从a到d是否有一条单边路径,接着查找两条边的路径,以此类推. 所以在原有的基础上,我们需要一个数组来保存从一个顶点到下一个顶点的所有边.命名为edgeTo.新的广度优先搜索代码如下: function bfs(s){//广度优先搜索 for(var i=0;i&lt;this.vertices;i++){//由于先进行深度优先搜索,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pK2Vw3.html" rel="bookmark">浅谈轮播图（原生JavaScript实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在各种轮播图插件,玲琅满目,用起来也非常方便,通常只需要选择元素然后传入参数就可以了.但是,和授人以鱼不如授人以渔一样的道理,不管怎样最基本的轮播图原理还是应当掌握的.这样不仅有利于我们自己写出来满足自己要求的轮播图,同时也对我们更好的使用其他插件有帮助.当然,最重要的是扎实我们的JavaScript基本功! 切入正题. 轮播,顾名思义,就是图片的循环&quot;播放&quot;.播放可以自动(定时器)也可以手动(按钮).轮播的精要其实是切换,切换可以是上下左右不同方向的移动来实现切换,移动可以匀速小步			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MorpDy4.html" rel="bookmark">从思维导图中学习javascript第三章数组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1对数组的操作方法: 1. push():在数组末尾添加数组 2.unshift():在数组头部添加元素 3.concat()合并两个数组 4pop()删除返回数组的最后一个元素 5shift()删除并返回数组的第一个元素 splice(参数1,参数2,参数3): 删除任意数量的项:1要删除的起始下标2要删除的项数 在制定位置插入指定的项:1.起始下标2.0(不删除任何项)3.要插入的项 替换任意数量的项:1.起始下标2.要删除的项数3.要插入的项 slice(参数1,参数2):从已有数组中选取			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kL5Bz3.html" rel="bookmark">从思维导图中学习javascript第七章DOM基本操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有多重要不多说			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e8DNEM.html" rel="bookmark">从思维导图中学习javascript第六章函数基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
							</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzypJy4.html" rel="bookmark">从思维导图中学习javascript第八章正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1用到时候自己查阅			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AK1y50.html" rel="bookmark">从思维导图中学习javascript第四章流程语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
							</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KavPj4.html" rel="bookmark" class="title">phper談談最近重構代碼的感受&lpar;3&rpar;</a>
					<div>
						这篇文章本来该和同一系列的文章一起写的,因为最近换工作的缘故滞后了.重构是非常细碎的叠加,有很多值得注意的地方. 1.消灭过多的临时变量. 有时候过多的无意义的临时变量,真心让人抓狂,特别是过了比较长 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDbEP0.html" rel="bookmark" class="title">外排序</a>
					<div>
						外排序 外排序(External sorting)是指能够处理极大量数据的排序算法.通常来说,外排序处理的数据不能一次装入内存,只能放在读写较慢的外存储器(通常是硬盘)上.外排序通常采用的是一种&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywL5n3.html" rel="bookmark" class="title">对象文件映射（ODM &lpar;Object-Document Mapper&rpar;）</a>
					<div>
						除了可以 映射关系数据库的表 之外,Phalcon还可以使用NoSQL数据库如MongoDB等.Phalcon中的ODM具有可以非常容易的实现如下功能:CRUD,事件,验证等. 因为NoSQL数据库中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vELKa0.html" rel="bookmark" class="title">HDU 2639 Bone Collector II</a>
					<div>
						Bone Collector II Time Limit: 2000ms Memory Limit: 32768KB This problem will be judged on HDU. Origi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OmeYgM.html" rel="bookmark" class="title">nodejs使用supervisor插件调试效率</a>
					<div>
						supervisor的安装也很简单: 直接用npm安装既可,键入命令: npm -g install supervisor 这里注意一点的就是,supervisor必须安装到全局,如果你不安装到全局, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQNPj3.html" rel="bookmark" class="title">MySQL57安装图解</a>
					<div>
						MySQL57安装图解... ============================= 0-需要准备的安装包 =================== 1在百度下载MySQl ============ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDELkM.html" rel="bookmark" class="title">2-2</a>
					<div>
						为方便储户,某银行拟开发计算机储蓄系统.储户填写的存款单或取款单由业务员输入系统,如果是存款,系统记录存款人姓名.住址.存款类型.存款日期.利率等信息,并印出存款单给储户:如果是取款,系统计算利息并印 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pe7DJM.html" rel="bookmark" class="title">&lbrack;个人论文&rsqb;  深度神经网络在面部情感分析系统中的应用与改良</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2Rgq3.html" rel="bookmark" class="title">background-image中url找不到路径，背景图像无法显示</a>
					<div>
						&lt;div id=&quot;body_left_secend_1&quot;&gt;                        &lt;img src=&quot;~/Images/imag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZkbP0.html" rel="bookmark" class="title">移动端html touch事件</a>
					<div>
						诸如智能手机和平板电脑一类的移动设备通常会有一(capacitive touch-sensitivescreen),以捕捉用户的手指所做的交互.随着移动网络的发展,其能够支持越来越复杂的应用,web开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q8YqQ3.html" rel="bookmark" class="title">50个C&sol;C&plus;&plus;经典面试题</a>
					<div>
						C/C++经典面试题  面试题1:变量的声明和定义有什么区别 为变量分配地址和存储空间的称为定义,不分配地址的称为声明.一个变量可以在多个地方声明, 但是只在一个地方定义.加入extern 修饰的是变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQLo80.html" rel="bookmark" class="title">Nginx系列一：信号与配置</a>
					<div>
						一.Nginx与信号 Nginx支持平滑重启,相比于Apache,修改了配置文件后可以不需要先停止程序,再重新启动. 1.启动 nginx –c nginx.conf 其中,-c nginx.conf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aO5DE4.html" rel="bookmark" class="title">0548-apache两种工作模式介绍及配置优化</a>
					<div>
						apache常用工作模式有两种,区别?worker模式:1.线程模式 2.占用资源少 3.稳定性略差 4.并发大prefork模式:1.进程模式 2.占用资源多 3.稳定 4.并发一般apache默认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWLPlb0.html" rel="bookmark" class="title">电话诈骗之思考&vert;安全是什么？</a>
					<div>
						大家好!本人菜鸟!在这里闲谈一些安全知识.欢迎交流,指导,谩骂就算了!最近关于电话炸骗的事情,时有发生,严重的还可以致人死亡! 帖子地址:http://bbs.ichunqiu.com/thread- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQrJxM.html" rel="bookmark" class="title">我的暑期MVC培训</a>
					<div>
						大学的第一个暑假选择了留校,并不是因为不想回家,因为学校有一个KPP项目培训,使用MVC框架开发信息管理系统,这又是一个陌生的东西,即使web下学期就会学到了,不过学校既然启动了这个项目,应该有不同于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqrey3.html" rel="bookmark" class="title">淘宝政策</a>
					<div>
						2015淘宝年度卖家大会顺利召开 http://c.fm.taobao.com/message/pc/get.html?msg_id=9220137364806818565&amp;session=1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471Gz10.html" rel="bookmark" class="title">【Newtonsoft&period;Json】Window Phone Json解析开发包</a>
					<div>
						WP从服务器.API交换数据一般都是用JSON格式字符串. 下面介绍用Newtonsoft.Json来处理JSON. 准备 1.到 http://json.codeplex.com/ 下载Newton ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqPAV0.html" rel="bookmark" class="title">工作台流水线厂家批发专业定制</a>
					<div>
						华森是一家专业生产工作台流水线的厂家,在工作台流水线的质量和价格上有着明显的优势.             工作台流水线是在一定的线路上连续输送货物搬运机械设备,又称输送线或者输送机.按照输送系列产品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWNjJ0.html" rel="bookmark" class="title">monkeyrunner 之android自动化测试学习（一）</a>
					<div>
						monkeyrunner要学习,必须有的是启动了avd,如果不知道怎么启动avd,请看我上一篇的内容,本文主要讲述我在模拟器上使用monkeyrunner做的第一个测试. 1.终端打开monkeyru ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmjgPM.html" rel="bookmark" class="title">swoole新手教程01-环境搭建及扩展安装</a>
					<div>
						写在前面的废话 &lt;swoole源代码分析&gt;已经写了13章,整个swoole的核心架构基本都分析的差点儿相同了.于是心里一直以来想整理swoole的文档并写一份教程的想法就再度浮了出来. 实 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
